Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp	(revision 92814)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.cpp	(revision 92815)
@@ -324,5 +324,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "DHCP server isn't enabled ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> is set to obtain the address "
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> is set to obtain the address "
                                                    "automatically but the corresponding DHCP server is not enabled.")
                                                    .arg(strName));
@@ -334,5 +334,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Invalid IPv4 address ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> does not "
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> does not "
                                                    "currently have a valid IPv4 address.")
                                                    .arg(strName));
@@ -344,6 +344,6 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Invalid IPv4 mask ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> does not "
-                                                   "currently have a valid IPv4 network mask.")
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> does not "
+                                                   "currently have a valid IPv4 mask.")
                                                    .arg(strName));
 }
@@ -354,5 +354,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Invalid IPv6 address ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> does not "
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> does not "
                                                    "currently have a valid IPv6 address.")
                                                    .arg(strName));
@@ -364,5 +364,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Invalid IPv6 prefix length ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> does not "
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> does not "
                                                    "currently have a valid IPv6 prefix length.")
                                                    .arg(strName));
@@ -374,5 +374,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Invalid DHCP server address ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> does not "
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> does not "
                                                    "currently have a valid DHCP server address.")
                                                    .arg(strName));
@@ -384,5 +384,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Invalid DHCP server mask ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> does not "
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> does not "
                                                    "currently have a valid DHCP server mask.")
                                                    .arg(strName));
@@ -394,5 +394,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Invalid DHCP lower address ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> does not "
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> does not "
                                                    "currently have a valid DHCP server lower address bound.")
                                                    .arg(strName));
@@ -404,5 +404,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Invalid DHCP upper address ..."),
-        QApplication::translate("UIMessageCenter", "Host interface <nobr><b>%1</b></nobr> does not "
+        QApplication::translate("UIMessageCenter", "Network <nobr><b>%1</b></nobr> does not "
                                                    "currently have a valid DHCP server upper address bound.")
                                                    .arg(strName));
@@ -414,5 +414,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "No name specified ..."),
-        QApplication::translate("UIMessageCenter", "No new name specified for the NAT network previously called <b>%1</b>.")
+        QApplication::translate("UIMessageCenter", "No new name specified for the network previously called <b>%1</b>.")
                                                    .arg(strName));
 }
@@ -423,5 +423,5 @@
     createMessage(
         QApplication::translate("UIMessageCenter", "Name already busy ..."),
-        QApplication::translate("UIMessageCenter", "The name <b>%1</b> is being used for several NAT networks.")
+        QApplication::translate("UIMessageCenter", "The name <b>%1</b> is being used for several networks.")
                                                    .arg(strName));
 }
Index: trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h	(revision 92814)
+++ trunk/src/VBox/Frontends/VirtualBox/src/notificationcenter/UINotificationObjects.h	(revision 92815)
@@ -432,5 +432,5 @@
         static void cannotFindCloudNetwork(const CVirtualBox &comVBox, const QString &strNetworkName);
         /** Notifies about inability to find host network interface.
-          * @param  comHost  Brings the host being search through.
+          * @param  comHost           Brings the host being search through.
           * @param  strInterfaceName  Brings interface name. */
         static void cannotFindHostNetworkInterface(const CHost &comHost, const QString &strInterfaceName);